Subject: [PATCH net-next 0/6] Ability to peek full socket queue

From: Pavel Emelyanov <[email-masked]>
Date: Tue, 21 Feb 2012 21:30:06 +0400

Hi.

This is an attempt to implement the ability to read socket's queue without
removing skbs from it. Using MSG_PEEK doesn't work for unix sockets, both
dgram and stream.

The proposal is to implement the SO_PEEK_OFF sockopt which specifies an
offset in bytes where to start peeking the data from.

I've already sent an example of how this can look, and since nobody objected
about the concept itself, here's the "official" v1. This includes all the unix
socket types and (hopefully) addresses locking issues David pointed out.

Signed-off-by: Pavel Emelyanov <[email-masked]>